
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#define READAHEAD_CACHEDIR "/etc/initng/cache"
#define READAHEAD_CACHE_FILE "/etc/initng/cache/readahead"

/* Defines how often we should trim the database, every 10 boots per default */
#define TRIM_EVERY_X_BOOT 10
/* Defines how many cache hits we require when we trim the database */
#define MINIMUM_CACHE_HITS_ON_TRIM 6

#define add_to_db(name) proc_db = add_to_db_real(name,strlen(name),get_time_since_boot(),1,proc_db)
#define merge_to_db(name,seconds_since_boot,hits) proc_db = add_to_db_real(name,strlen(name),seconds_since_boot,hits,proc_db)


typedef struct pproc_data proc_data;

struct pproc_data
{
    char *name;
    int hits;
    int seconds_since_boot;     /* Seconds into boot this file is used */
    proc_data *next;
};
proc_data *proc_db;
int boots_since_last_trim;


proc_data *add_to_db_real(char *name, int len, int seconds_since_boot,
                          int hits, proc_data * db);
void clean_database(void);

#define trim_database() proc_db = trim_database_real(proc_db);
proc_data *trim_database_real(proc_data * db);
void save_database(void);
void load_database(void);
void sort_database(void);

#define free_database() free_database_real(proc_db); proc_db = NULL;
void free_database_real(proc_data * db);
time_t get_time_since_boot(void);
